
#ifndef __JINROH_H
#define __JINROH_H

const LimitNum = 15;
enum { System=-1, Augur=0,Phycic,Hunter,Sharer,Madman,Wolf,Villager };
enum { Gray=0,White=1,Black=2 };

class WolfBBS;

// ̏
class State {
	friend WolfBBS;
	int day,time;
	bool live[LimitNum];
	int hang[LimitNum];
public:
	State() {
	}
	
	void init() {
		day = 1;
		time = 0;
	}
	int getday() { return day; }
	int gettime() { return time; }
	bool getlive(int i) { return live[i]; }
	int gethang(int i) { return hang[i]; }
	void tomorror() { day++;time=0; }
	void spendtime() { time++; }

	int getlivenum() {
		int n=0;
		for( int i=0;i<LimitNum;i++ ) {
			if( live[i] ) n++;
		}
	}
};

// be
struct Word {
	int player;
	enum TYPE {
		MORNING=0,HANGED,WOLFED,	// VXe

		CO,
		AUGUR_RESULT,PHYCIC_RESULT,
		PROPOSE_AUGURY,PROPOSE_HANG,
		//LEADER,AGREE,DISAGREE,

		USER = 0x1000,	// [U[gR[h
		WOLF = 0x2000,	// ԃO

	} type;
	int data,data2;

	void sets( TYPE t,int d,int d2 = 0 );  // VXebZ[Wp
	void set( TYPE t,int d,int d2 = 0 );

	void print();
};

class WolfBBS;

// ݂w͏ɂ܂Dl̈ӌ͕CȂD
class Person {
	friend WolfBBS;
public:
	virtual void Listen( State &s,Word w ) { // l̔
		// 
	}
	virtual bool Talk( State &s,Word &w ) { // @ƂɌĂяo
		return false;	// ׂȂ
	}
	virtual int Augury( State &s ) { return -1; }  // 肢tꍇɒׂԂ
	virtual int Hang( State &s ) { return -1; } // ݂wDsȒlƂ܂ɂȂ
	virtual int Eat( State &s ) { return -1; } // Tꍇ̋򂢎w
	virtual int Hunt( State &s ) { return -1; } // lꍇ̎
protected:
	int myplayerno;
	bool me( int i ) {
		return i==myplayerno;
	}
};

class WolfBBS
{
	State state;
	struct People {
		int type;
		Person *person;
	} people[LimitNum];
	int maxp;
	bool bprint;
public:
	WolfBBS();
	void init();
	void enableprint();
	void destroy();
	void shuffle();
	void add( int type,Person *person );
	bool oneday( bool *win );
protected:
	void talk();
	void augury();
	void hang();
	void wolf();
	void tomorror();
	bool check( bool *village );
	void printstatus();
};

template<class T> Person* born() { return new T; }

struct Init {
	int type;
	int num;
	Person* (*born)();
};

#endif //__JINROH_H
